# anolis_release number must be even higher, because dual-lived modules will be broken otherwise
%define anolis_release 16

%global perl_version    5.36.3
%global perl_epoch      4
%global tapsetdir   %{_datadir}/systemtap/tapset
%global perl5_testdir   %{_libexecdir}/perl5-tests

%global __provides_exclude_from .*%{_docdir}|.*%{perl_archlib}/.*\\.pl$|.*%{perl_privlib}/.*\\.pl$
%global __requires_exclude_from %{_docdir}
%global __provides_exclude perl\\((VMS|Win32|BSD::|DB\\)$)
%global __requires_exclude perl\\((VMS|BSD::|Win32|Tk|Mac::|Your::Module::Here)

%global priv_lib     %{_prefix}/share/perl5
%global arch_lib     %{_libdir}/perl5
%global perl_vendorlib  %{priv_lib}/vendor_perl
%global perl_vendorarch %{arch_lib}/vendor_perl
%global perl_abi    %(echo '%{perl_version}' | sed 's/^\\([^.]*\\.[^.]*\\).*/\\1/')

%bcond_without cplusplus_test
%bcond_without gdbm
%bcond_without groff
%bcond_without turkish_test
%bcond_with    syslog_test
%bcond_without systemtap
%bcond_with    tcsh
%bcond_without test

%undefine _package_note_file

Name:           perl
License:        GPL+ or Artistic
Epoch:          %{perl_epoch}
Version:        %{perl_version}
Release:        %{anolis_release}%{?dist}
Summary:        Practical Extraction and Report Language
Url:            https://www.perl.org/
Source0:        https://www.cpan.org/src/5.0/perl-%{perl_version}.tar.xz
Source3:        macros.perl
Source4:        perl.stp
Source5:        perl-example.stp
Source6:        Pod-Html-license-clarification
Source7:        gendep.macros
%if %{defined perl_bootstrap}
%include %{SOURCE7}
%endif

Source10:       remove_bootstrap_files
Source11:       perl-doc-filelist 
Source12:       bootstrap-packages

Patch1:         perl-perlbug-tag.patch
Patch2:         perl-5.8.0-libdir64.patch
Patch3:         perl-5.10.0-libresolv.patch
Patch4:         perl-USE_MM_LD_RUN_PATH.patch
Patch5:         perl-5.22.1-Provide-ExtUtils-MM-methods-as-standalone-ExtUtils-M.patch
Patch6:         perl-5.10.0-x86_64-io-test-failure.patch
Patch7:         perl-5.14.1-offtest.patch
Patch8:         perl-5.16.3-create_libperl_soname.patch
Patch9:         perl-5.22.0-Install-libperl.so-to-shrpdir-on-Linux.patch
Patch10:        perl-5.34.0-Destroy-GDBM-NDBM-ODBM-SDBM-_File-objects-only-from-.patch
Patch11:        perl-5.22.1-Replace-EU-MM-dependnecy-with-EU-MM-Utils-in-IPC-Cmd.patch
Patch12:        perl-5.27.8-hints-linux-Add-lphtread-to-lddlflags.patch
Patch13:        perl-5.28.0-Pass-CFLAGS-to-dtrace.patch
Patch200:       perl-5.16.3-Link-XS-modules-to-libperl.so-with-EU-CBuilder-on-Li.patch
Patch201:       perl-5.16.3-Link-XS-modules-to-libperl.so-with-EU-MM-on-Linux.patch
Patch202:       perl-5.36.0-Add-definition-of-OPTIMIZE-to-.ph-files.patch
Patch203:       perl-5.36.3-add-Perl_my_strlcat-and-Perl_my_strlcpy-symbol.patch

BuildRequires:  bash bzip2-devel coreutils findutils gcc glibc-common make
BuildRequires:  sed tar zlib-devel
BuildRequires:  gcc
%if %{with gdbm}
BuildRequires:  gdbm-devel
%endif
%if %{with groff}
BuildRequires:  groff-base
%endif
%if !%{defined perl_bootstrap}
BuildRequires:  perl-interpreter perl-generators
%endif
%if %{with systemtap}
BuildRequires:  systemtap-sdt-devel
%endif
%if %{with tcsh}
BuildRequires:  tcsh
%endif

%if %{with test}
%if %{with cplusplus_test}
BuildRequires:  gcc-c++
%endif
BuildRequires:  procps
%if %{with turkish_test}
BuildRequires:  glibc-langpack-tr
%endif
%if %{with syslog_test}
BuildRequires:  rsyslog
%endif
%endif

BuildRequires: systemtap-sdt-dtrace

%global perl_compat perl(:MODULE_COMPAT_5.36.3)

Requires:       perl-interpreter = %{perl_epoch}:%{perl_version}-%{release}
Requires:       perl-libs = %{perl_epoch}:%{perl_version}-%{release}
Requires:       perl-devel = %{perl_epoch}:%{perl_version}-%{release}
Requires:       perl-macros perl-utils
%if %{defined perl_bootstrap}
%gendep_perl
%endif

Requires:       perl-Archive-Tar perl-Attribute-Handlers
Requires:       perl-AutoLoader perl-AutoSplit perl-autouse perl-autodie
Requires:       perl-B perl-base perl-Benchmark
Requires:       perl-bignum perl-blib perl-Carp perl-Class-Struct
Requires:       perl-Compress-Raw-Bzip2 perl-Compress-Raw-Zlib
Requires:       perl-Config-Extensions perl-Config-Perl-V
Requires:       perl-constant
Requires:       perl-CPAN perl-CPAN-Meta perl-CPAN-Meta-Requirements perl-CPAN-Meta-YAML
Requires:       perl-Data-Dumper perl-DBM_Filter perl-debugger perl-deprecate
Requires:       perl-Devel-Peek perl-Devel-PPPort perl-Devel-SelfStubber
Requires:       perl-diagnostics
Requires:       perl-Digest perl-Digest-MD5 perl-Digest-SHA
Requires:       perl-DirHandle perl-doc perl-Dumpvalue perl-DynaLoader
Requires:       perl-Encode perl-Encode-devel perl-encoding perl-encoding-warnings
Requires:       perl-English
Requires:       perl-Env perl-Errno perl-experimental perl-Exporter
Requires:       perl-ExtUtils-CBuilder perl-ExtUtils-Constant perl-ExtUtils-Command
Requires:       perl-ExtUtils-Embed perl-ExtUtils-Install perl-ExtUtils-MakeMaker
Requires:       perl-ExtUtils-Manifest perl-ExtUtils-Miniperl
Requires:       perl-ExtUtils-MM-Utils perl-ExtUtils-ParseXS
Requires:       perl-Fcntl perl-fields perl-File-DosGlob perl-File-Fetch
Requires:       perl-File-Basename perl-File-Compare perl-File-Copy
Requires:       perl-File-Find perl-File-Path perl-File-stat
Requires:       perl-File-Temp perl-FileCache perl-FileHandle perl-filetest
Requires:       perl-Getopt-Long perl-Getopt-Std perl-JSON-PP perl-less
Requires:       perl-Hash-Util perl-Hash-Util-FieldHash perl-HTTP-Tiny
Requires:       perl-if perl-IO-Socket-IP perl-IO perl-IO-Compress
Requires:       perl-IO-Zlib perl-IPC-Cmd perl-IPC-Open3 perl-IPC-SysV
Requires:       perl-I18N-Collate perl-I18N-Langinfo perl-I18N-LangTags
Requires:       perl-lib perl-libnet perl-libnetcfg perl-MIME-Base64
Requires:       perl-locale perl-Locale-Maketext perl-Locale-Maketext-Simple
Requires:       perl-Math-BigInt perl-Math-BigInt-FastCalc perl-Math-BigRat
Requires:       perl-Math-Complex perl-Memoize perl-meta-notation
Requires:       perl-Module-CoreList perl-Module-CoreList-tools
Requires:       perl-Module-Load perl-Module-Load-Conditional
Requires:       perl-Module-Loaded perl-Module-Metadata
%if %{with gdbm}
Requires:       perl-NDBM_File perl-GDBM_File perl-ODBM_File
%endif
Requires:       perl-mro perl-Net perl-Net-Ping perl-NEXT
Requires:       perl-Opcode perl-open perl-overload perl-overloading
Requires:       perl-parent perl-PathTools perl-Params-Check perl-perlfaq
Requires:       perl-PerlIO-via-QuotedPrint perl-Perl-OSType perl-ph
Requires:       perl-Pod-Checker perl-Pod-Escapes perl-Pod-Functions
Requires:       perl-Pod-Html perl-Pod-Perldoc perl-Safe perl-Scalar-List-Utils
Requires:       perl-Pod-Simple perl-Pod-Usage perl-podlators perl-POSIX
Requires:       perl-Search-Dict perl-SelectSaver perl-Storable perl-subs
Requires:       perl-SelfLoader perl-sigtrap perl-Socket perl-sort
Requires:       perl-Symbol perl-Sys-Hostname perl-Sys-Syslog perl-Term-ReadLine
Requires:       perl-Term-ANSIColor perl-Term-Cap perl-Term-Complete
Requires:       perl-Test perl-Test-Harness perl-Test-Simple perl-Text-Tabs+Wrap
Requires:       perl-Text-Abbrev perl-Text-Balanced perl-Text-ParseWords
Requires:       perl-Thread perl-Thread-Queue perl-Thread-Semaphore
Requires:       perl-threads perl-threads-shared
Requires:       perl-Tie perl-Tie-File perl-Tie-Memoize perl-Tie-RefHash
Requires:       perl-Time perl-Time-HiRes perl-Time-Local perl-Time-Piece
Requires:       perl-Unicode-Collate perl-Unicode-Normalize perl-Unicode-UCD
Requires:       perl-User-pwent perl-vars perl-version perl-vmsish

Provides:       perl-core = %{perl_version}-%{release}
Obsoletes:      perl-core < 5.26.0


%description
Perl is a general-purpose programming language originally developed for text manipulation and now used for a wide range of tasks including system administration, web development, network programming, GUI development, and more.

The language is intended to be practical (easy to use, efficient, complete) rather than beautiful (tiny, elegant, minimal). Its major features are that it's easy to use, supports both procedural and object-oriented (OO) programming, has powerful built-in support for text processing, and has one of the world's most impressive collections of third-party modules.

%package interpreter
Summary:        Standalone executable Perl interpreter
License:        GPL+ or Artistic
Version:        %{perl_version}
Epoch:          %{perl_epoch}
Requires:       perl-libs = %{perl_epoch}:%{perl_version}-%{release}
Suggests:       perl-doc = %{perl_version}-%{release}
%if %{defined perl_bootstrap}
%gendep_perl_interpreter
%endif
Requires(post): perl-libs
Obsoletes:      perl-suidperl <= 4:5.12.2
Obsoletes:      perl < 4:5.26.0

%description interpreter
This is a Perl interpreter as a standalone executable %{_bindir}/perl
required for handling Perl scripts. It does not provide all the other Perl
modules or tools.
Install this package if you want to program in Perl or enable your system to
handle Perl scripts with %{_bindir}/perl interpreter.
If your script requires some Perl modules, you can install them with
"perl(MODULE)" where "MODULE" is a name of required module. E.g. install
"perl(Test::More)" to make Test::More Perl module available.
If you need all the Perl modules that come with upstream Perl sources, so
called core modules, install perl package.
If you only need perl run-time as a shared library, i.e. Perl interpreter
embedded into another application, the only essential package is perl-libs.
Perl header files can be found in perl-devel package.
Perl utils like "h2ph" or "perlbug" can be found in perl-utils package.
Perl debugger, usually invoked with "perl -d", is available in perl-debugger
package.

%package libs
Summary:        The libraries for the perl run-time
License:        (GPL+ or Artistic) and BSD and HSRL and MIT and UCD and Public domain
Provides:       %perl_compat
Provides:       perl(:MODULE_COMPAT_5.36.0)
Provides:	perl(:MODULE_COMPAT_5.36.1)
Provides:	perl(:MODULE_COMPAT_5.36.2)
Provides:       perl(:VERSION) = %{perl_version}
Provides:       perl(:WITH_64BIT) perl(:WITH_ITHREADS) perl(:WITH_THREADS)
Provides:       perl(:WITH_LARGEFILES) perl(:WITH_PERLIO) perl(bytes_heavy.pl)
Provides:       perl(unicore::Name) perl(utf8_heavy.pl)
Requires:       perl(DynaLoader) perl(Encode) perl(File::Spec)
%if %{with gdbm}
Suggests:       perl(GDBM_File) perl(ODBM_File)
Recommends:     perl(NDBM_File)
%endif
%if %{defined perl_bootstrap}
%gendep_perl_libs
%endif

%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}^perl\\((charnames|DynaLoader)\\)$

%description libs
The is a perl run-time (interpreter as a shared library and include
directories).


%package devel
Summary:        Header files for use in perl development
License:        (GPL+ or Artistic) and UCD
%if %{with systemtap}
Requires:       systemtap-sdt-devel
%endif
Requires:       perl(ExtUtils::ParseXS) perl(Devel::PPPort)
Requires:       system-rpm-config libxcrypt-devel
Requires:       perl-libs = %{perl_epoch}:%{perl_version}-%{release}
Recommends:     perl-doc = %{perl_version}-%{release}

%if %{defined perl_bootstrap}
%gendep_perl_devel
%endif

%description devel
This package contains header files and development modules.
Most perl packages will need to install perl-devel to build.


%package macros
Summary:        Macros for rpmbuild
License:        GPL+ or Artistic
BuildArch:      noarch
Requires:       perl-interpreter
%if %{defined perl_bootstrap}
%gendep_perl_macros
%endif

%description macros
RPM macros that are handy when building binary RPM packages.


%package tests
Summary:        The Perl test suite
License:        GPL+ or Artistic
AutoReqProv:    0
Requires:       perl
%if %{defined perl_bootstrap}
%gendep_perl_tests
%endif

%description tests
This package contains the test suite included with Perl %{perl_version}.
Install this if you want to test your Perl installation (binary and core
modules).


%package utils
Summary:        Utilities packaged with the Perl distribution
License:        GPL+ or Artistic
Epoch:          0
Version:        %{perl_version}
BuildArch:      noarch
Requires:       perl-libs = %{perl_epoch}:%{perl_version}-%{release}
%if %{defined perl_bootstrap}
%gendep_perl_utils
%endif
Conflicts:      perl < 4:5.22.0

%description utils
Several utilities which come with Perl distribution like h2ph, perlbug,
perlthanks, and pl2pm. Some utilities are provided by more specific
packages like perldoc by perl-Pod-Perldoc and splain by perl-diagnostics.

%package Attribute-Handlers
Summary:        Simpler definition of attribute handlers
License:        GPL+ or Artistic
Epoch:          0
Version:        1.02
BuildArch:      noarch
%if %{defined perl_bootstrap}
%gendep_perl_Attribute_Handlers
%endif
Conflicts:      perl < 4:5.22.0

%description Attribute-Handlers
This Perl module, when inherited by a package, allows that package's class to
define attribute handler subroutines for specific attributes. Variables and
subroutines subsequently defined in that package, or in packages derived from
that package may be given attributes with the same names as the attribute
handler subroutines, which will then be called in one of the compilation
phases (i.e. in a "BEGIN", "CHECK", "INIT", or "END" block).

%package AutoLoader
Summary:        Load subroutines only on demand
License:        GPL+ or Artistic
Epoch:          0
Version:        5.74
BuildArch:      noarch
Requires:       perl(Carp)
%if %{defined perl_bootstrap}
%gendep_perl_AutoLoader
%endif
Conflicts:      perl < 4:5.30.1

%description AutoLoader
The AutoLoader module works with the AutoSplit module and the "__END__" token
to defer the loading of some subroutines until they are used rather than
loading them all at once.

%package AutoSplit
Summary:        Split a package for automatic loading
License:        GPL+ or Artistic
Epoch:          0
Version:        5.74
BuildArch:      noarch
Requires:       perl(Carp)
%if %{defined perl_bootstrap}
%gendep_perl_AutoSplit
%endif
Conflicts:      perl < 4:5.30.1

%description AutoSplit
Split up your program into files that the AutoLoader module can handle. It is
used by both the standard Perl libraries and by the ExtUtils::MakeMaker
utility, to automatically configure libraries for automatic loading.

%package autouse
Summary:        Postpone load of modules until a function is used
License:        GPL+ or Artistic
Epoch:          0
Version:        1.11
BuildArch:      noarch
Requires:       perl(Carp) perl(warnings)
%if %{defined perl_bootstrap}
%gendep_perl_autouse
%endif
Conflicts:      perl < 4:5.30.1

%description autouse
If a module is not loaded yet, then the autouse declaration declares functions
in the current package. When these functions are called, they load the package
and substitute themselves with the correct definitions.

%package B
Summary:        Perl compiler backend
License:        GPL+ or Artistic
Epoch:          0
Version:        1.83
Requires:       perl(Data::Dumper) perl(overloading) perl(XSLoader)
%if %{defined perl_bootstrap}
%gendep_perl_B
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description B
The "B" module supplies classes which allow a Perl program to delve into its
own innards. It is the module used to implement the backends of the Perl
compiler.

%package base
Summary:        Establish an ISA relationship with base classes at compile time
License:        GPL+ or Artistic
Epoch:          0
Version:        2.27
BuildArch:      noarch
Requires:       perl(Carp)
%if %{defined perl_bootstrap}
%gendep_perl_base
%endif
Conflicts:      perl < 4:5.30.1

%description base
"base" module allows you to both load one or more modules, while setting up
inheritance from those modules at the same time.  Unless you are using the
"fields" pragma, consider this module discouraged in favor of the
lighter-weight "parent".

%package Benchmark
Summary:        Benchmark running times of Perl code
License:        GPL+ or Artistic
Epoch:          0
Version:        1.23
%if %{defined perl_bootstrap}
%gendep_perl_Benchmark
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description Benchmark
The Benchmark module encapsulates a number of routines to help you figure out
how long it takes to execute some code.

%package blib
Summary:        Use uninstalled version of a package
License:        GPL+ or Artistic
Epoch:          0
Version:        1.07
%if %{defined perl_bootstrap}
%gendep_perl_blib
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description blib
This module looks for MakeMaker-like "blib" directory structure starting in
given or current directory and working back up to five levels of directories.
It is intended for use on command line with -M option as a way of testing
arbitrary scripts against an uninstalled version of a package.

%package Class-Struct
Summary:        Declare struct-like data types as Perl classes
License:        GPL+ or Artistic
Epoch:          0
Version:        0.66
%if %{defined perl_bootstrap}
%gendep_perl_Class_Struct
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description Class-Struct
Class::Struct module exports a single function struct(). Given a list of
element names and types, and optionally a class name, struct() creates a
Perl 5 class that implements a struct-like data structure.

%package Config-Extensions
Summary:        Hash lookup of which Perl core extensions were built
License:        GPL+ or Artistic
Epoch:          0
Version:        0.03
%if %{defined perl_bootstrap}
%gendep_perl_Config_Extensions
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description Config-Extensions
The Config::Extensions module provides a hash %%Extensions containing all the
core extensions that were enabled for this perl.

%package DBM_Filter
Summary:        Filter DBM keys and values
License:        GPL+ or Artistic
Epoch:          0
Version:        0.06
Requires:       perl(Compress::Zlib) perl(Encode)
%if %{defined perl_bootstrap}
%gendep_perl_DBM_Filter
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}^perl\\(Tie::Hash\\)$

%description DBM_Filter
This module provides an interface that allows filters to be applied to tied
hashes associated with DBM files.

%package debugger
Summary:        Perl debugger
License:        GPL+ or Artistic
Epoch:          0
Version:        1.60
BuildArch:      noarch
Provides:       perl(dumpvar.pl) = %{perl_version}
Provides:       perl(perl5db.pl) = %{version}
Requires:       perl(Cwd) perl(feature) perl(IO::Socket) perl(mro)
Requires:       perl(meta_notation) = %{perl_version}
Requires:       perl(Term::ReadLine) perl(threads) perl(threads::shared)
Requires:       perl(vars) perl(warnings)

%if !%{defined perl_bootstrap}
Suggests:       perl(PadWalker) >= 0.08
%endif

%if %{defined perl_bootstrap}
%gendep_perl_debugger
%endif

Recommends:     perl(Carp) perl(Config) perl(File::Path) perl(POSIX)
Recommends:     perl(Devel::Peek) perl(IO::Handle) perl(File::Basename)
Conflicts:      perl < 4:5.30.1

%description debugger
This is the perl debugger. It is loaded automatically by Perl when you invoke
a script with "perl -d". There is also "DB" module contained for
a programmatic interface to the debugging API.

%package deprecate
Summary:        Perl pragma for deprecating the inclusion of a module in core
License:        GPL+ or Artistic
Epoch:          0
Version:        0.04
Requires:       perl(Carp) perl(Config)
%if %{defined perl_bootstrap}
%gendep_perl_deprecate
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description deprecate
"deprecate" pragma simplifies the maintenance of dual-life modules that will no
longer be included in the Perl core in a future Perl release, but are
still included currently. The purpose of the pragma is to alert users to the
status of such a module by issuing a warning that encourages them to install
the module from CPAN, so that a future upgrade to a perl which omits the
module will not break their code.

%package Devel-Peek
Summary:        A data debugging tool for the XS programmer
License:        GPL+ or Artistic
Epoch:          0
Version:        1.32
%if %{defined perl_bootstrap}
%gendep_perl_Devel_Peek
%endif
Conflicts:      perl < 4:5.22.0

%description Devel-Peek
Devel::Peek contains functions which allows raw Perl data types to be
manipulated from a Perl script. This is used by those who do XS programming to
check that the data they are sending from C to Perl looks as they think it
should look.

%package Devel-SelfStubber
Summary:        Generate stubs for a SelfLoading module
License:        GPL+ or Artistic
Epoch:          0
Version:        1.06
BuildArch:      noarch
%if %{defined perl_bootstrap}
%gendep_perl_Devel_SelfStubber
%endif
Conflicts:      perl < 4:5.22.0

%description Devel-SelfStubber
Devel::SelfStubber prints the stubs you need to put in the module before the
__DATA__ token (or you can get it to print the entire module with stubs
correctly placed). The stubs ensure that if a method is called, it will get
loaded. They are needed specifically for inherited autoloaded methods.

%package diagnostics
Summary:        Produce verbose warning diagnostics
License:        GPL+ or Artistic
Epoch:          0
Version:        1.39
BuildArch:      noarch
Requires:       perl-libs = %{perl_epoch}:%{perl_version}-%{release}
Requires:       perl(Getopt::Std)
%if %{defined perl_bootstrap}
%gendep_perl_diagnostics
%endif
Conflicts:      perl-utils < 5.30.1 perl-interpreter < 4:5.30.1

%description diagnostics
The diagnostics module extends the terse diagnostics normally emitted by both
the perl compiler and the perl interpreter (from running perl with a -w switch
or "use warnings"), augmenting them with the more explicative and endearing
descriptions found in perldiag. splain tool explains perl messages found on
standard input.

%package DirHandle
Summary:        Supply object methods for directory handles
License:        GPL+ or Artistic
Epoch:          0
Version:        1.05
BuildArch:      noarch
Requires:       perl(warnings)
%if %{defined perl_bootstrap}
%gendep_perl_DirHandle
%endif
Conflicts:      perl < 4:5.30.1

%description DirHandle
There is no reason to use this module nowadays. The DirHandle module provides
an alternative interface to the opendir(), closedir(), readdir(), and
rewinddir() functions. Since Perl 5.6, opendir() alone has been all you need
for lexical handles.

%package doc
Summary:        Perl language documentation
License:        (GPL+ or Artistic) and UCD and Public Domain
Epoch:          0
Version:        %{perl_version}
BuildArch:      noarch
Recommends:     perl-Pod-Perldoc
Conflicts:      perl < 4:5.30.1

%description doc
This is a documentation for Perl language. It's provided in POD and manual
page format.

%package Dumpvalue
Summary:        Screen dump of Perl data
License:        GPL+ or Artistic
Epoch:          0
Version:        2.27
BuildArch:      noarch
Recommends:     perl(Devel::Peek)
%if %{defined perl_bootstrap}
%gendep_perl_Dumpvalue
%endif
Conflicts:      perl < 4:5.30.1

%description Dumpvalue
Dumpvalue module enables you to print a content of variables and other Perl
data structures.

%package DynaLoader
Summary:        Dynamically load C libraries into Perl code
License:        GPL+ or Artistic
Epoch:          0
Version:        1.52
Requires:       perl(Carp)
%if %{defined perl_bootstrap}
%gendep_perl_DynaLoader
%endif
Conflicts:      perl < 4:5.30.1

%description DynaLoader
The DynaLoader module defines a standard generic interface to the dynamic
linking mechanisms available on many platforms. Its primary purpose is to
implement automatic dynamic loading of Perl modules. For a simpler interface,
see XSLoader module.

%package encoding-warnings
Summary:        Warn on implicit encoding conversions
License:        GPL+ or Artistic
Epoch:          0
Version:        0.13
BuildArch:      noarch
Requires:       perl(Carp)
%if %{defined perl_bootstrap}
%gendep_perl_encoding_warnings
%endif
Conflicts:      perl < 4:5.30.1

%description encoding-warnings
As of Perl 5.26.0, this module has no effect. The internal Perl feature that
was used to implement this module has been removed.  Hence, if you load this
module on Perl 5.26.0, you will get one warning that the module is no longer
supported; and the module will do nothing thereafter.

%package English
Summary:        Nice English or awk names for ugly punctuation variables
License:        GPL+ or Artistic
Epoch:          0
Version:        1.11
Requires:       perl(Carp) perl(warnings)
%if %{defined perl_bootstrap}
%gendep_perl_English
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description English
This module provides aliases for the built-in variables whose names no one
seems to like to read.

%package Errno
Summary:        System errno constants
License:        GPL+ or Artistic
Epoch:          0
Version:        1.36
Requires:       perl-libs = %{perl_epoch}:%{perl_version}-%{release}
Requires:       perl(Carp)
%if %{defined perl_bootstrap}
%gendep_perl_Errno
%endif
Conflicts:      perl < 4:5.22.0

%description Errno
"Errno" defines and conditionally exports all the error constants defined in
your system "errno.h" include file. It has a single export tag, ":POSIX",
which will export all POSIX defined error numbers.

%package ExtUtils-Constant
Summary:        Generate XS code to import C header constants
License:        GPL+ or Artistic
Epoch:          0
Version:        0.25
BuildArch:      noarch
Requires:       perl(Data::Dumper)
Conflicts:      perl-interpreter < 4:5.30.1
%if %{defined perl_bootstrap}
%gendep_perl_ExtUtils_Constant
%endif

%description ExtUtils-Constant
ExtUtils::Constant facilitates generating C and XS wrapper code to allow
Perl modules to AUTOLOAD constants defined in C library header files.

%package ExtUtils-Embed
Summary:        Utilities for embedding Perl in C/C++ applications
License:        GPL+ or Artistic
Epoch:          0
Version:        1.35
Requires:       perl-devel
%if %{defined perl_bootstrap}
%gendep_perl_ExtUtils_Embed
%endif
BuildArch:      noarch

%description ExtUtils-Embed
Utilities for embedding Perl in C/C++ applications.

%package ExtUtils-Miniperl
Summary:        Write the C code for perlmain.c
License:        GPL+ or Artistic
Epoch:          0
Version:        1.11
Requires:       perl-devel
%if %{defined perl_bootstrap}
%gendep_perl_ExtUtils_Miniperl
%endif
BuildArch:      noarch

%description ExtUtils-Miniperl
writemain() takes an argument list of directories containing archive libraries
that relate to perl modules and should be linked into a new perl binary. It
writes a corresponding perlmain.c file that is a plain C file containing all
the bootstrap code to make the If the first argument to writemain() is a
reference to a scalar it is used as the file name to open for output. Any other
reference is used as the file handle to write to. Otherwise output defaults to
STDOUT.

%package Fcntl
Summary:        File operation options
License:        GPL+ or Artistic
Epoch:          0
Version:        1.15
%if %{defined perl_bootstrap}
%gendep_perl_Fcntl
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description Fcntl
Fcntl module provides file operation related options.

%package fields
Summary:        Compile-time class fields
License:        GPL+ or Artistic
Epoch:          0
Version:        2.27
BuildArch:      noarch
Requires:       perl(base) perl(Carp) perl(Hash::Util)
%if %{defined perl_bootstrap}
%gendep_perl_fields
%endif
Conflicts:      perl < 4:5.30.1

%description fields
The "fields" pragma enables compile-time and run-time verified class fields.

%package File-Basename
Summary:        Parse file paths into directory, file name, and suffix
License:        GPL+ or Artistic
Epoch:          0
Version:        2.85
BuildArch:      noarch
Requires:       perl(Carp) perl(re)
%if %{defined perl_bootstrap}
%gendep_perl_File_Basename
%endif
Conflicts:      perl < 4:5.30.1

%description File-Basename
These routines allow you to parse file paths into their directory, file name,
and suffix.

%package File-Compare
Summary:        Compare files or file handles
License:        GPL+ or Artistic
Epoch:          0
Version:        1.100.700
BuildArch:      noarch
Requires:       perl(Carp)
%if %{defined perl_bootstrap}
%gendep_perl_File_Compare
%endif
Conflicts:      perl < 4:5.30.1

%description File-Compare
A File::Compare Perl module provides functions for comparing a content of two
files specified by a file name or a file handle.

%package File-Copy
Summary:        Copy files or file handles
License:        GPL+ or Artistic
Epoch:          0
Version:        2.39
BuildArch:      noarch
Requires:       perl(Carp) perl(File::Basename)
%if %{defined perl_bootstrap}
%gendep_perl_File_Copy
%endif
Conflicts:      perl < 4:5.30.1

%description File-Copy
A File::Copy module provides two basic functions, copy and move, which are
useful for getting the contents of a file from one place to another.

%package File-DosGlob
Summary:        DOS-like globbing
License:        GPL+ or Artistic
Epoch:          0
Version:        1.12
Requires:       perl(Text::ParseWords)
%if %{defined perl_bootstrap}
%gendep_perl_File_DosGlob
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description File-DosGlob
This Perl module implements DOS-like globbing with a few enhancements. It
is largely compatible with perlglob.exe in all but one respect--it understands
wild cards in directory components.

%package File-Find
Summary:        Traverse a directory tree
License:        GPL+ or Artistic
Epoch:          0
Version:        1.40
Recommends:     perl(Scalar::Util)
%if %{defined perl_bootstrap}
%gendep_perl_File_Find
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description File-Find
These are functions for searching through directory trees doing work on each
file found similar to the Unix find command.

%package File-stat
Summary:        By-name interface to Perl built-in stat functions
License:        GPL+ or Artistic
Epoch:          0
Version:        1.12
BuildArch:      noarch
Requires:       perl(Symbol)
%if %{defined perl_bootstrap}
%gendep_perl_File_stat
%endif
Conflicts:      perl < 4:5.30.1

%description File-stat
This module overrides the core stat() and lstat() functions, replacing them
with versions that return File::stat objects. This object has methods that
return the similarly named structure field name from the stat(2) function.

%package FileCache
Summary:        Keep more files open than the system permits
License:        GPL+ or Artistic
Epoch:          0
Version:        1.10
BuildArch:      noarch
%if %{defined perl_bootstrap}
%gendep_perl_FileCache
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description FileCache
The "cacheout" function will make sure that there's a file handle open
for reading or writing available as the path name you give it. It
automatically closes and re-opens files if you exceed your system
maximum number of file descriptors, or the suggested maximum.

%package FileHandle
Summary:        Object methods for file handles
License:        GPL+ or Artistic
Epoch:          0
Version:        2.03
BuildArch:      noarch
Requires:       perl(Exporter)
Recommends:     perl(Fcntl)
%if %{defined perl_bootstrap}
%gendep_perl_FileHandle
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description FileHandle
This is an object-oriented interface for opening files and performing
input/output operations on them.

%package filetest
Summary:        Perl pragma to control the filetest permission operators
License:        GPL+ or Artistic
Epoch:          0
Version:        1.03
BuildArch:      noarch
%if %{defined perl_bootstrap}
%gendep_perl_filetest
%endif
Conflicts:      perl < 4:5.30.1

%description filetest
The default behavior of file test operators (e.g. "-r") is to use the simple
mode bits as returned by the stat() family of system calls. However, many
operating systems have additional features to define more complex access
rights, for example ACLs (Access Control Lists). For such environments, "use
filetest" may help the permission operators to return results more consistent
with other tools.

%package FindBin
Summary:        Locate a directory of an original Perl script
License:        GPL+ or Artistic
Epoch:          0
Version:        1.53
%if %{defined perl_bootstrap}
%gendep_perl_FindBin
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description FindBin
Locates the full path to the script bin directory to allow the use of paths
relative to the bin directory.

%if %{with gdbm}
%package GDBM_File
Summary:        Perl5 access to the gdbm library
License:        GPL+ or Artistic
Epoch:          1
Version:        1.23
%if %{defined perl_bootstrap}
%gendep_perl_GDBM_File
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description GDBM_File
GDBM_File is a module which allows Perl programs to make use of the facilities
provided by the GNU gdbm library.
%endif

%package Getopt-Std
Summary:        Process single-character switches with switch clustering
License:        GPL+ or Artistic
Epoch:          0
Version:        1.13
%if %{defined perl_bootstrap}
%gendep_perl_Getopt_Std
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description Getopt-Std
The Getopt::Std module provides functions for processing single-character
switches with switch clustering. Pass one argument which is a string
containing all switches to be recognized.

%package Hash-Util
Summary:        General-utility hash subroutines
License:        GPL+ or Artistic
Epoch:          0
Version:        0.28
Requires:       perl(Hash::Util::FieldHash) perl(XSLoader)
%if %{defined perl_bootstrap}
%gendep_perl_Hash_Util
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description Hash-Util
Hash::Util contains special functions for manipulating hashes that don't
really warrant a keyword.

%package Hash-Util-FieldHash
Summary:        Support for inside-out classes
License:        GPL+ or Artistic
Epoch:          0
Version:        1.26
Requires:       perl(XSLoader)
%if %{defined perl_bootstrap}
%gendep_perl_Hash_Util_FieldHash
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description Hash-Util-FieldHash
Hash::Util::FieldHash offers a number of functions in support of the
inside-out technique of class construction.

%package if
Summary:        Use a Perl module if a condition holds
License:        GPL+ or Artistic
Epoch:          0
Version:        0.61.000
%if %{defined perl_bootstrap}
%gendep_perl_if
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description if
The "if" module is used to conditionally load another module.

%package IO
Summary:        Perl input/output modules
License:        GPL+ or Artistic
Epoch:          0
Version:        1.50
%if %{defined perl_bootstrap}
%gendep_perl_IO
%endif
Conflicts:      perl < 4:5.22.0

%description IO
This is a collection of Perl input/output modules.

%package IPC-Open3
Summary:        Open a process for reading, writing, and error handling
License:        GPL+ or Artistic
Epoch:          0
Version:        1.22
Requires:       perl(Fcntl) perl(IO::Pipe) perl(POSIX) perl(warnings)
%if %{defined perl_bootstrap}
%gendep_perl_IPC_Open3
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description IPC-Open3
These are functions that spawn a given command and connects the standard
output of the command for reading, standard output for writing, and standard
error output for handling the errors.

%package I18N-Collate
Summary:        Compare 8-bit scalar data according to the current locale
License:        GPL+ or Artistic
Epoch:          0
Version:        1.02
%if %{defined perl_bootstrap}
%gendep_perl_I18N_Collate
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description I18N-Collate
This module provides you with objects that will collate according to your
national character set. This module is deprecated. See the perllocale manual
page for further information.

%package I18N-Langinfo
Summary:        Query locale information
License:        GPL+ or Artistic
Epoch:          0
Version:        0.21
%if %{defined perl_bootstrap}
%gendep_perl_I18N_Langinfo
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description I18N-Langinfo
The langinfo() function queries various locale information that can be used to
localize output and user interfaces. It uses the current underlying locale,
regardless of whether or not it was called from within the scope of "use
locale".

%package I18N-LangTags
Summary:        Functions for dealing with RFC 3066 language tags
License:        GPL+ or Artistic
Epoch:          0
Version:        0.45
Requires:       perl(integer) perl(warnings)
%if %{defined perl_bootstrap}
%gendep_perl_I18N_LangTags
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description I18N-LangTags
Language tags are a formalism, described in RFC 3066, for declaring what
language form (language and possibly dialect) a given chunk of information is
in. This library provides functions for common tasks involving language tags
as they are needed in a variety of protocols and applications.

%package less
Summary:        Perl pragma to request less of something
License:        GPL+ or Artistic
Epoch:          0
Version:        0.03
BuildArch:      noarch
%if %{defined perl_bootstrap}
%gendep_perl_less
%endif
Conflicts:      perl < 4:5.30.1

%description less
"use less ...;" is a Perl user-pragma. If you're very lucky some code you're
using will know that you asked for less CPU usage or RAM or fat or... we just
can't know.

%package lib
Summary:        Manipulate @INC at compile time
License:        GPL+ or Artistic
Epoch:          0
Version:        0.65
Requires:       perl(Carp)
%if %{defined perl_bootstrap}
%gendep_perl_lib
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description lib
This module simplifies the manipulation of @INC at compile time.

%package libnetcfg
Summary:        Configure libnet
License:        GPL+ or Artistic
Epoch:          %perl_epoch
Version:        %perl_version
BuildArch:      noarch
%if %{defined perl_bootstrap}
%gendep_perl_libnetcfg
%endif
Conflicts:      perl-devel < 4:5.22.0

%description libnetcfg
The libnetcfg utility can be used to configure the libnet.

%package locale
Summary:        Pragma to use or avoid POSIX locales for built-in operations
License:        GPL+ or Artistic
Epoch:          0
Version:        1.10
Requires:       perl(Carp) perl(POSIX)
%if %{defined perl_bootstrap}
%gendep_perl_locale
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description locale
This pragma tells the compiler to enable (or disable) the use of POSIX locales
for built-in operations (for example, LC_CTYPE for regular expressions,
LC_COLLATE for string comparison, and LC_NUMERIC for number formatting). Each
"use locale" or "no locale" affects statements to the end of the enclosing
block.

%package Locale-Maketext-Simple
Summary:        Simple interface to Locale::Maketext::Lexicon
License:        MIT
Epoch:          1
Version:        0.21
%if %{defined perl_bootstrap}
%gendep_perl_Locale_Maketext_Simple
%endif
BuildArch:      noarch

%description Locale-Maketext-Simple
This module is a simple wrapper around Locale::Maketext::Lexicon, designed
to alleviate the need of creating Language Classes for module authors.

%package Math-Complex
Summary:        Complex numbers and trigonometric functions
License:        GPL+ or Artistic
Epoch:          0
Version:        1.59
%if %{defined perl_bootstrap}
%gendep_perl_Math_Complex
%endif
BuildArch:      noarch
Conflicts:      perl < 4:5.22.0

%description Math-Complex
This package lets you create and manipulate complex numbers. By default, Perl
limits itself to real numbers, but an extra "use" statement brings full
complex support, along with a full set of mathematical functions typically
associated with and/or extended to complex numbers.

%package Memoize
Summary:        Transparently speed up functions by caching return values
License:        GPL+ or Artistic
Epoch:          0
Version:        1.03
%if %{defined perl_bootstrap}
%gendep_perl_Memoize
%endif
BuildArch:      noarch
Conflicts:      perl < 4:5.22.0

%description Memoize
Memoizing a function makes it faster by trading space for time. It does
this by caching the return values of the function in a table. If you call
the function again with the same arguments, memoize jumps in and gives
you the value out of the table, instead of letting the function compute
the value all over again.

%package meta-notation
Summary:        Change nonprintable characters below 0x100 into printables
License:        GPL+ or Artistic
Epoch:          0
Version:        %{perl_version}
BuildArch:      noarch
Provides:       perl(meta_notation) = %{perl_version}
%if %{defined perl_bootstrap}
%gendep_perl_meta_notation
%endif
Conflicts:      perl < 4:5.30.1

%description meta-notation
Returns a copy of the input string with the nonprintable characters below
0x100 changed into printables. Any ASCII printables or above 0xFF are
unchanged.

%package Module-Loaded
Summary:        Mark modules as loaded or unloaded
License:        GPL+ or Artistic
Epoch:          1
Version:        0.08
%if %{defined perl_bootstrap}
%gendep_perl_Module_Loaded
%endif
BuildArch:      noarch

%description Module-Loaded
When testing applications, often you find yourself needing to provide
functionality in your test environment that would usually be provided by
external modules. Rather than munging the %%INC by hand to mark these external
modules as loaded, so they are not attempted to be loaded by perl, this module
offers you a very simple way to mark modules as loaded and/or unloaded.

%package mro
Summary:        Method resolution order
License:        GPL+ or Artistic
Epoch:          0
Version:        1.26
%if %{defined perl_bootstrap}
%gendep_perl_mro
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description mro
The "mro" name space provides several utilities for dealing with method
resolution order and method caching in general.

%if %{with gdbm}
%package NDBM_File
Summary:        Tied access to ndbm files
License:        GPL+ or Artistic
Epoch:          0
Version:        1.15
%if %{defined perl_bootstrap}
%gendep_perl_NDBM_File
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description NDBM_File
NDBM_File establishes a connection between a Perl hash variable and a file in
ndbm format. You can manipulate the data in the file just as if it were in
a Perl hash, but when your program exits, the data will remain in the file, to
be used the next time your program runs.
%endif

%package Net
Summary:        By-name interface to Perl built-in network resolver
License:        GPL+ or Artistic
Epoch:          0
Version:        1.03
BuildArch:      noarch
Requires:       perl(Socket)
%if %{defined perl_bootstrap}
%gendep_perl_Net
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description Net
This package provide object-oriented interface to Perl built-in gethost*(),
getnet*(), getproto*(), and getserv*() functions.

%package NEXT
Summary:        Pseudo-class that allows method redispatch
License:        GPL+ or Artistic
Epoch:          0
Version:        0.69
%if %{defined perl_bootstrap}
%gendep_perl_NEXT
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description NEXT
The NEXT module adds a pseudo-class named "NEXT" to any program that uses it.
If a method "m" calls "$self->NEXT::m()", the call to "m" is redispatched as
if the calling method had not originally been found.

%if %{with gdbm}
%package ODBM_File
Summary:        Tied access to odbm files
License:        GPL+ or Artistic
Epoch:          0
Version:        1.17
%if %{defined perl_bootstrap}
%gendep_perl_ODBM_File
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description ODBM_File
ODBM_File establishes a connection between a Perl hash variable and a file in
odbm format. You can manipulate the data in the file just as if it were in
a Perl hash, but when your program exits, the data will remain in the file, to
be used the next time your program runs.
%endif

%package Opcode
Summary:        Disable named opcodes when compiling a perl code
License:        GPL+ or Artistic
Epoch:          0
Version:        1.57
%if %{defined perl_bootstrap}
%gendep_perl_Opcode
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description Opcode
The Opcode module allows you to define an operator mask to be in effect when
perl next compiles any code. Attempting to compile code which contains
a masked opcode will cause the compilation to fail with an error. The code
will not be executed.

%package open
Summary:        Perl pragma to set default PerlIO layers for input and output
License:        GPL+ or Artistic
Epoch:          0
Version:        1.13
Requires:       perl(Carp) perl(Encode) perl(encoding)
%if %{defined perl_bootstrap}
%gendep_perl_open
%endif
Conflicts:      perl < 4:5.20.2
BuildArch:      noarch

%description open
The "open" pragma serves as one of the interfaces to declare default "layers"
(also known as "disciplines") for all I/O.

%package overload
Summary:        Overloading Perl operations
License:        GPL+ or Artistic
Epoch:          0
Version:        1.35
BuildArch:      noarch
Requires:       perl(mro) perl(Scalar::Util) perl(overloading)
%if %{defined perl_bootstrap}
%gendep_perl_overload
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description overload
The "overload" pragma allows overloading of Perl operators for a class. To
overload built-in functions, see "Overriding Built-in Functions" in perlsub
POD instead.

%package overloading
Summary:        Perl pragma to lexically control overloading
License:        GPL+ or Artistic
Epoch:          0
Version:        0.02
BuildArch:      noarch
Requires:       perl(Carp)
%if %{defined perl_bootstrap}
%gendep_perl_overloading
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description overloading
Overloading pragma allows you to lexically disable or enable overloading.

%package ph
Summary:        Selected system header files converted to Perl headers
License:        GPL+ or Artistic
Epoch:          0
Version:        %{perl_version}
Requires:       perl-libs = %{perl_epoch}:%{perl_version}-%{release}
Requires:       perl(warnings)
Provides:       perl(sys/ioctl.ph) = %{perl_version}
Provides:       perl(sys/syscall.ph) = %{perl_version}
Provides:       perl(syscall.ph) = %{perl_version}
%if %{defined perl_bootstrap}
%gendep_perl_ph
%endif
Conflicts:      perl < 4:5.30.1

%description ph
Contemporary Perl still refers to some Perl header (ph) files although it does
not build them anymore. This is a prebuilt collection of the referred files.
If you miss other ones, you can generate them with h2ph tool from perl-utils
package.

%package Pod-Functions
Summary:        Group Perl functions as in perlfunc POD
License:        GPL+ or Artistic
Epoch:          0
Version:        1.14
BuildArch:      noarch
Requires:       perl-libs = %{perl_epoch}:%{perl_version}-%{release}
%if %{defined perl_bootstrap}
%gendep_perl_Pod_Functions
%endif
Conflicts:      perl < 4:5.30.1

%description Pod-Functions
This module enumerates the Perl functions that are documented in perlfunc POD.

%package Pod-Html
Summary:        Convert POD files to HTML
License:        GPL+ or Artistic
Epoch:          0
Version:        1.33
%if %{defined perl_bootstrap}
%gendep_perl_Pod_Html
%endif
BuildArch:      noarch
Conflicts:      perl < 4:5.22.0

%description Pod-Html
This package converts files from POD format (see perlpod) to HTML format. It
can automatically generate indexes and cross-references, and it keeps a cache
of things it knows how to cross-reference.

%package POSIX
Summary:        Perl interface to IEEE Std 1003.1
License:        GPL+ or Artistic
Epoch:          0
Version:        2.03
Requires:       perl(Carp)
Requires:	perl(locale)
%if %{defined perl_bootstrap}
%gendep_perl_POSIX
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description POSIX
The POSIX module permits you to access all (or nearly all) the standard POSIX
1003.1 identifiers. Many of these identifiers have been given Perl interfaces.

%package Safe
Summary:        Compile and execute code in restricted compartments
License:        GPL+ or Artistic
Epoch:          0
Version:        2.43
%if %{defined perl_bootstrap}
%gendep_perl_Safe
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description Safe
The Safe extension module allows the creation of compartments in which Perl
code can be evaluated. Please note that the restriction is not suitable for
security purposes.

%package Search-Dict
Summary:        Search for a key in a dictionary file
License:        GPL+ or Artistic
Epoch:          0
Version:        1.07
Requires:       perl(feature)
%if %{defined perl_bootstrap}
%gendep_perl_Search_Dict
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description Search-Dict
This module sets file position in a file handle to be first line greater than
or equal (string-wise) to a key.

%package SelectSaver
Summary:        Save and restore selected file handle
License:        GPL+ or Artistic
Epoch:          0
Version:        1.02
BuildArch:      noarch
%if %{defined perl_bootstrap}
%gendep_perl_SelectSaver
%endif
Conflicts:      perl < 4:5.30.1

%description SelectSaver
A "SelectSaver" object contains a reference to the file handle that was
selected when it was created. When the object is destroyed, it re-selects the
file handle that was selected when it was created.

%package SelfLoader
Summary:        Load functions only on demand
License:        GPL+ or Artistic
Epoch:          0
Version:        1.26
BuildArch:      noarch
Requires:       perl(Carp)
%if %{defined perl_bootstrap}
%gendep_perl_SelfLoader
%endif
Conflicts:      perl < 4:5.22.0

%description SelfLoader
This Perl module tells its users that functions in a package are to be
autoloaded from after the "__DATA__" token. See also "Autoloading" in
perlsub.

%package sigtrap
Summary:        Perl pragma to enable simple signal handling
License:        GPL+ or Artistic
Epoch:          0
Version:        1.10
BuildArch:      noarch
Requires:       perl(meta_notation) = %{perl_version}
Requires:       perl(Symbol)
%if %{defined perl_bootstrap}
%gendep_perl_sigtrap
%endif
Conflicts:      perl < 4:5.30.1

%description sigtrap
The sigtrap pragma is a simple interface for installing signal handlers.

%package sort
Summary:        Perl pragma to control sort() behavior
License:        GPL+ or Artistic
Epoch:          0
Version:        2.05
BuildArch:      noarch
Requires:       perl(Carp) perl(warnings)
%if %{defined perl_bootstrap}
%gendep_perl_sort
%endif
Conflicts:      perl < 4:5.30.1

%description sort
With the "sort" pragma you can control the behavior of the builtin "sort()"
function.

%package subs
Summary:        Perl pragma to predeclare subroutine names
License:        GPL+ or Artistic
Epoch:          0
Version:        1.04
BuildArch:      noarch
%if %{defined perl_bootstrap}
%gendep_perl_subs
%endif
Conflicts:      perl < 4:5.30.1

%description subs
This will predeclare all the subroutines whose names are in the list,
allowing you to use them without parentheses (as list operators) even
before they're declared.

%package Symbol
Summary:        Manipulate Perl symbols and their names
License:        GPL+ or Artistic
Epoch:          0
Version:        1.09
BuildArch:      noarch
%if %{defined perl_bootstrap}
%gendep_perl_Symbol
%endif
Conflicts:      perl < 4:5.30.1

%description Symbol
The Symbol module provides functions for manipulating Perl symbols.

%package Sys-Hostname
Summary:        Try every conceivable way to get a hostname
License:        GPL+ or Artistic
Epoch:          0
Version:        1.24
Suggests:       perl(POSIX)
Requires:       perl(XSLoader)
%if %{defined perl_bootstrap}
%gendep_perl_Sys_Hostname
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description Sys-Hostname
It attempts several methods of getting the system hostname and then caches the
result.

%package Term-Complete
Summary:        Perl word completion
License:        GPL+ or Artistic
Epoch:          0
Version:        1.403
%if %{defined perl_bootstrap}
%gendep_perl_Term_Complete
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description Term-Complete
"Complete" routine provides word completion on a list of words in the array.

%package Term-ReadLine
Summary:        Perl interface to various read-line packages
License:        GPL+ or Artistic
Epoch:          0
Version:        1.17
Requires:       perl(Term::Cap)
%if %{defined perl_bootstrap}
%gendep_perl_Term_ReadLine
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description Term-ReadLine
This package is just a front end to some other packages. It's a stub to
set up a common interface to the various read-line implementations found
on CPAN (under the "Term::ReadLine::*" name space).

%package Test
Summary:        Simple framework for writing test scripts
License:        GPL+ or Artistic
Epoch:          0
Version:        1.31
Requires:       perl(File::Temp)
%if %{defined perl_bootstrap}
%gendep_perl_Test
%endif
BuildArch:      noarch
Conflicts:      perl < 4:5.22.0

%description Test
The Test Perl module simplifies the task of writing test files for Perl modules,
such that their output is in the format that Test::Harness expects to see.

%package Text-Abbrev
Summary:        Create an abbreviation table from a list
License:        GPL+ or Artistic
Epoch:          0
Version:        1.02
%if %{defined perl_bootstrap}
%gendep_perl_Text_Abbrev
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description Text-Abbrev
It stores all unambiguous truncations of each element of a list as keys in
an associative array. The values are the original list elements.

%package Thread
Summary:        Manipulate threads in Perl (for old code only)
License:        GPL+ or Artistic
Epoch:          0
Version:        3.05
BuildArch:      noarch
%if %{defined perl_bootstrap}
%gendep_perl_Thread
%endif
Conflicts:      perl < 4:5.30.1

%description Thread
This Thread module served as the front end to the old-style thread model,
called 5005threads, that has been removed in version 5.10.

For old code and interim backwards compatibility, the Thread module has been
reworked to function as a front end for the new interpreter threads (ithreads)
model. However, some previous functionality is not available. Further, the
data sharing models between the two thread models are completely different,
and anything to do with data sharing has to be thought differently.

You are strongly encouraged to migrate any existing threaded code to the new
model (i.e., use the threads and threads::shared modules) as soon as possible.

%package Tie
Summary:        Base classes for tying variables
License:        GPL+ or Artistic
Epoch:          0
Version:        4.6
BuildArch:      noarch
%if %{defined perl_bootstrap}
%gendep_perl_Tie
%endif
Conflicts:      perl < 4:5.30.1

%description Tie
These are Perl modules that helps connecting classes with arrays, hashes,
handles, and scalars.

%package Tie-File
Summary:        Access the lines of a disk file via a Perl array
License:        GPLv2+ or Artistic
Epoch:          0
Version:        1.06
%if %{defined perl_bootstrap}
%gendep_perl_Tie_File
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description Tie-File
Tie::File represents a regular text file as a Perl array. Each element in the
array corresponds to a record in the file. The first line of the file is
element 0 of the array; the second line is element 1, and so on.  The file is
not loaded into memory, so this will work even for gigantic files.  Changes to
the array are reflected in the file immediately.

%package Tie-Memoize
Summary:        Add data to a hash when needed
License:        GPLv2+ or Artistic
Epoch:          0
Version:        1.1
Requires:       perl(Carp) perl(Tie::ExtraHash)
%if %{defined perl_bootstrap}
%gendep_perl_Tie_Memoize
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description Tie-Memoize
This package allows a tied hash to load its values automatically on the first
access, and to use the cached value on the following accesses.

%package Time
Summary:        By-name interface to Perl built-in time functions
License:        GPL+ or Artistic
Epoch:          0
Version:        1.03
BuildArch:      noarch
%if %{defined perl_bootstrap}
%gendep_perl_Time
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description Time
This package provides an object-oriented interface to Perl built-in gmtime()
and localtime () functions.

%package Time-Piece
Summary:        Time objects from localtime and gmtime
License:        (GPL+ or Artistic) and BSD
Epoch:          0
Version:        1.3401
%if %{defined perl_bootstrap}
%gendep_perl_Time_Piece
%endif

%description Time-Piece
The Time::Piece module replaces the standard localtime and gmtime functions
with implementations that return objects.  It does so in a backwards compatible
manner, so that using localtime or gmtime as documented in perlfunc still
behave as expected.

%package Thread-Semaphore
Summary:        Thread-safe semaphores
License:        GPL+ or Artistic
Epoch:          0
Version:        2.13
Requires:       perl(Carp)
%if %{defined perl_bootstrap}
%gendep_perl_Thread_Semaphore
%endif
BuildArch:      noarch
Conflicts:      perl-interpreter < 4:5.30.1

%description Thread-Semaphore
Semaphores provide a mechanism to regulate access to resources. Unlike locks,
semaphores aren't tied to particular scalars, and so may be used to control
access to anything you care to use them for. Semaphores don't limit their
values to zero and one, so they can be used to control access to some resource
that there may be more than one of (e.g., file handles). Increment and
decrement amounts aren't fixed at one either, so threads can reserve or return
multiple resources at once.

%package Unicode-UCD
Summary:        Unicode character database
License:        GPL+ or Artistic
Epoch:          0
Version:        0.78
BuildArch:      noarch
Requires:       perl(Storable)
%if %{defined perl_bootstrap}
%gendep_perl_Unicode_UCD
%endif
Conflicts:      perl < 4:5.30.1

%description Unicode-UCD
The Unicode::UCD module offers a series of functions that provide a simple
interface to the Unicode Character Database.

%package User-pwent
Summary:        By-name interface to Perl built-in user name resolver
License:        GPL+ or Artistic
Epoch:          0
Version:        1.03
BuildArch:      noarch
%if %{defined perl_bootstrap}
%gendep_perl_User_pwent
%endif
Conflicts:      perl-interpreter < 4:5.30.1

%description User-pwent
This package provides an object-oriented interface to Perl build-in getgr*()
and getpw*() functions.

%package vars
Summary:        Perl pragma to predeclare global variable names
License:        GPL+ or Artistic
Epoch:          0
Version:        1.05
BuildArch:      noarch
Requires:       perl(Carp)
%if %{defined perl_bootstrap}
%gendep_perl_vars
%endif
Conflicts:      perl < 4:5.30.1

%description vars
This pragma will predeclare all the variables whose names are in the
list, allowing you to use them under "use strict", and disabling any
typo warnings for them.

For use with variables in the current package for a single scope, the
functionality provided by this pragma has been superseded by "our"
declarations, available in Perl v5.6.0 or later, and use of this pragma is
discouraged.

%package vmsish
Summary:        Perl pragma to control VMS-specific language features
License:        GPL+ or Artistic
Epoch:          0
Version:        1.04
BuildArch:      noarch
%if %{defined perl_bootstrap}
%gendep_perl_vmsish
%endif
Conflicts:      perl < 4:5.30.1

%description vmsish
The "vmsish" pragma control VMS-specific features of the Perl language. If
you're not running VMS, this module does nothing.

%if %{defined perl_bootstrap}
%include %{SOURCE12}
%endif

%prep
%autosetup -p1 -n perl-%{perl_version}

install -m 0644 %{SOURCE5} .
cp %{SOURCE6} .

recode()
{
        iconv -f "${2:-iso-8859-1}" -t utf-8 < "$1" > "${1}_"
        touch -r "$1" "${1}_"
        mv -f "${1}_" "$1"
}

find . -name \*.orig -exec rm -fv {} \;

sed -i 's|BUILD_ZLIB      = True|BUILD_ZLIB      = False|
    s|INCLUDE         = ./zlib-src|INCLUDE         = %{_includedir}|
    s|LIB             = ./zlib-src|LIB             = %{_libdir}|' \
    cpan/Compress-Raw-Zlib/config.in

rm -rf cpan/Compress-Raw-Zlib/zlib-src
rm -rf cpan/Compress-Raw-Bzip2/bzip2-src
sed -i '/\(bzip2\|zlib\)-src/d' MANIFEST

%if !%{with gdbm}
rm -rf 'cpan/Memoize/Memoize/NDBM_File.pm'
sed -i '\|cpan/Memoize/Memoize/NDBM_File.pm|d' MANIFEST
%endif


%build
echo "RPM Build arch: %{_arch}"

/bin/sh Configure -des \
        -Doptimize="none" \
        -Dccflags="%{build_cflags}" \
        -Dldflags="%{build_ldflags}" \
        -Dccdlflags="-Wl,--enable-new-dtags %{build_ldflags}" \
        -Dlddlflags="-shared %{build_ldflags}" \
        -Dshrpdir="%{_libdir}" \
        -DDEBUGGING=-g \
        -Dversion=%{perl_version} \
        -Dmyhostname=localhost \
        -Dperladmin=root@localhost \
        -Dcc='%{__cc}' \
        -Dcf_by='Anolis' \
        -Dprefix=%{_prefix} \
%if %{without groff}
        -Dman1dir="%{_mandir}/man1" \
        -Dman3dir="%{_mandir}/man3" \
%endif
        -Dvendorprefix=%{_prefix} \
        -Dsiteprefix=%{_prefix}/local \
        -Dsitelib="%{_prefix}/local/share/perl5/%{perl_abi}" \
        -Dsitearch="%{_prefix}/local/%{_lib}/perl5/%{perl_abi}" \
        -Dprivlib="%{priv_lib}" \
        -Dvendorlib="%{perl_vendorlib}" \
        -Darchlib="%{arch_lib}" \
        -Dvendorarch="%{perl_vendorarch}" \
        -Darchname=%{_arch}-%{_os}-thread-multi \
        -Dlibpth="/usr/local/lib64 /lib64 %{_prefix}/lib64" \
        -Duseshrplib \
        -Dusethreads \
        -Duseithreads \
%if %{with systemtap}
        -Dusedtrace='/usr/bin/dtrace' \
%else
        -Uusedtrace \
%endif
        -Duselargefiles \
        -Dd_semctl_semun \
        -Di_db \
%if %{with gdbm}
        -Ui_ndbm \
        -Di_gdbm \
%endif
        -Di_shadow \
        -Di_syslog \
        -Dman3ext=3pm \
        -Duseperlio \
        -Dinstallusrbinperl=n \
        -Ubincompat5005 \
        -Uversiononly \
        -Dpager='/usr/bin/less -isr' \
        -Dd_gethostent_r_proto -Ud_endhostent_r_proto -Ud_sethostent_r_proto \
        -Ud_endprotoent_r_proto -Ud_setprotoent_r_proto \
        -Ud_endservent_r_proto -Ud_setservent_r_proto \
        -Dscriptdir='%{_bindir}' \
        -Dusesitecustomize \
        -Duse64bitint

BUILD_BZIP2=0
BZIP2_LIB=%{_libdir}
export BUILD_BZIP2 BZIP2_LIB

%global soname libperl.so.%{perl_abi}
test -L %soname || ln -s libperl.so %soname

%make_build

%install
%make_install

%global build_archlib %{buildroot}%{arch_lib}
%global build_privlib %{buildroot}%{priv_lib}
%global build_bindir  %{buildroot}%{_bindir}
%global new_perl LD_PRELOAD="%{build_archlib}/CORE/libperl.so" \\\
                 LD_LIBRARY_PATH="%{build_archlib}/CORE" \\\
                 PERL5LIB="%{build_archlib}:%{build_privlib}" \\\
                 %{build_bindir}/perl

mv "%{build_archlib}/CORE/libperl.so" "%{buildroot}%{_libdir}/libperl.so.%{perl_version}"
ln -s "libperl.so.%{perl_version}" "%{buildroot}%{_libdir}/%{soname}"
ln -s "libperl.so.%{perl_version}" "%{buildroot}%{_libdir}/libperl.so"
ln -s "../../libperl.so.%{perl_version}" "%{build_archlib}/CORE/libperl.so"
rm -f "%{build_archlib}/CORE/%{soname}"

install -p -m 755 utils/pl2pm %{build_bindir}/pl2pm

for i in sys/ioctl.h sys/syscall.h syscall.h
do
    %{new_perl} %{build_bindir}/h2ph -a -d %{build_archlib} $i || true
done

mkdir -p %{buildroot}%{perl_vendorarch}/auto
mkdir -p %{buildroot}%{perl_vendorlib}

mkdir -p %{buildroot}%{_rpmmacrodir}
install -p -m 644 %{SOURCE3} %{buildroot}%{_rpmmacrodir}

find %{buildroot} -type f -name '*.bs' -empty -delete
chmod -R u+w %{buildroot}/*

rm %{build_privlib}/ExtUtils/xsubpp
ln -s ../../../bin/xsubpp %{build_privlib}/ExtUtils/

rm %{build_archlib}/.packlist
rm %{build_archlib}/File/Spec/VMS.pm
rm %{buildroot}%{_mandir}/man3/File::Spec::VMS.3*
rm %{build_privlib}/ExtUtils/PL2Bat.pm
rm %{buildroot}%{_mandir}/man3/ExtUtils::PL2Bat.3*

mkdir -p %{buildroot}%{_mandir}/man1/
pushd %{buildroot}%{_mandir}/man1/
  for i in perl588delta.1 perldelta.1 ; do
    iconv -f MS-ANSI -t UTF-8 $i --output new-$i
    rm $i
    mv new-$i $i
  done
popd

mkdir -p %{buildroot}%{perl5_testdir}/perl-tests

tar -cf - t/ | ( cd %{buildroot}%{perl5_testdir}/perl-tests && tar -xf - )

for dir in `find ext/ -type d -name t -maxdepth 2` ; do
    tar -cf - $dir | ( cd %{buildroot}%{perl5_testdir}/perl-tests/t && tar -xf - )
done

%{new_perl} -MConfig -i -pn \
    -e 's"\A#!(?:perl|\./perl|/perl|/usr/bin/perl|/usr/bin/env perl)\b"$Config{startperl}"' \
    $(find %{buildroot}%{perl5_testdir}/perl-tests -type f)

%if %{with systemtap}
mkdir -p %{buildroot}%{tapsetdir}
%global libperl_stp libperl%{perl_version}.stp

sed \
  -e "s|LIBRARY_PATH|%{_libdir}/%{soname}|" \
  %{SOURCE4} \
  > %{buildroot}%{tapsetdir}/%{libperl_stp}
%endif

%if !%{defined perl_bootstrap}
%include %{SOURCE10}
%endif

%check
%if %{with test}
%{new_perl} -I/lib regen/lib_cleanup.pl
%{new_perl} -Ilib Porting/makemeta
pushd t
%{new_perl} -I../lib porting/customized.t --regen
popd
JOBS=$(printf '%%s' "%{?_smp_mflags}" | sed 's/.*-j\([0-9][0-9]*\).*/\1/')
LC_ALL=C TEST_JOBS=$JOBS make test_harness
%endif

%files

%files interpreter
%{_bindir}/perl
%{_bindir}/perl%{perl_version}
%{_mandir}/man1/{perl.1.zst,perlrun.1.zst}
%dir %{priv_lib}/pod
%{priv_lib}/pod/{perl.pod,perlrun.pod}

%files libs
%license Artistic Copying
%dir %{arch_lib}
%{arch_lib}/attributes.pm
%dir %{arch_lib}/auto
%dir %{arch_lib}/auto/attributes
%{arch_lib}/auto/attributes/attributes.so
%dir %{arch_lib}/auto/File
%dir %{arch_lib}/auto/File/Glob
%{arch_lib}/auto/File/Glob/Glob.so
%{arch_lib}/auto/{PerlIO,re,SDBM_File}
%{arch_lib}/{Config.*,Config_git.pl,Config_heavy.pl}
%dir %{arch_lib}/CORE
%{arch_lib}/CORE/libperl.so
%dir %{arch_lib}/File
%{arch_lib}/File/Glob.pm
%{arch_lib}/{PerlIO,re.pm,SDBM_File.pm}
%{_libdir}/libperl.so.*
%dir %{perl_vendorarch}
%dir %{perl_vendorarch}/auto
%dir %{priv_lib}
%{priv_lib}/{AnyDBM_File.pm,builtin.pm,bytes.pm,bytes_heavy.pl,_charnames.pm,charnames.pm,CORE.pod,feature.pm,integer.pm,Internals.pod,PerlIO.pm,strict.pm,unicore,UNIVERSAL.pm,utf8.pm,warnings,warnings.pm}
%dir %{priv_lib}/Tie
%{priv_lib}/Tie/Hash.pm
%dir %{priv_lib}/Tie/Hash
%{priv_lib}/Tie/Hash/NamedCapture.pm
%{priv_lib}/XSLoader.pm
%dir %{perl_vendorlib}
%{_mandir}/man3/{AnyDBM_File.*,attributes.*,builtin.*,bytes.*,charnames.*,Config.*,CORE.*,feature.3*,File::Glob.*,integer.*,Internals.*,PerlIO.*,PerlIO::encoding.*,PerlIO::mmap.*,PerlIO::scalar.*,PerlIO::via.*,re.*,SDBM_File.3*,strict.*,Tie::Hash.*,Tie::Hash::*,unicore*,utf8.*,warnings.*,warnings::*,UNIVERSAL.*,XSLoader.*}
%doc AUTHORS README Changes

%files devel
%{_bindir}/h2xs
%{_bindir}/perlivp
%{_mandir}/man1/{h2xs*,perlivp*}
%{arch_lib}/CORE/*.h
%dir %{priv_lib}/ExtUtils
%{priv_lib}/ExtUtils/typemap
%{_libdir}/libperl.so
%if %{with systemtap}
%dir %{_datadir}/systemtap
%dir %{_datadir}/systemtap/tapset
%{tapsetdir}/%{libperl_stp}
%doc perl-example.stp
%endif

%files macros
%{_rpmmacrodir}/macros.perl

%files tests
%{perl5_testdir}/

%files utils
%{_bindir}/{h2ph,perlbug,perlthanks,pl2pm}
%dir %{priv_lib}/pod
%{priv_lib}/pod/perlutil.pod
%{_mandir}/man1/{h2ph.*,perlbug.*,perlthanks.*,perlutil.*,pl2pm.*}

%files Attribute-Handlers
%{priv_lib}/Attribute
%{_mandir}/man3/Attribute::Handlers.*

%files AutoLoader
%{priv_lib}/AutoLoader.pm
%{_mandir}/man3/AutoLoader.3*

%files AutoSplit
%{priv_lib}/AutoSplit.pm
%{_mandir}/man3/AutoSplit.3*

%files autouse
%{priv_lib}/autouse.pm
%{_mandir}/man3/autouse.3*

%files B
%{arch_lib}/auto/B
%{arch_lib}/{B,B.pm,O.pm}
%{priv_lib}/B
%{_mandir}/man3/{B.*,B::*,O.*}

%files base
%{priv_lib}/base.pm
%{_mandir}/man3/base.3*

%files Benchmark
%{priv_lib}/Benchmark.pm
%{_mandir}/man3/Benchmark.*

%files blib
%{priv_lib}/blib.pm
%{_mandir}/man3/blib.*

%files Class-Struct
%{priv_lib}/Class
%{_mandir}/man3/Class::Struct.*

%files Config-Extensions
%dir %{priv_lib}/Config
%{priv_lib}/Config/Extensions.pm
%{_mandir}/man3/Config::Extensions.*

%files DBM_Filter
%{priv_lib}/{DBM_Filter,DBM_Filter.pm}
%{_mandir}/man3/{DBM_Filter.*,DBM_Filter::*}

%files debugger
%{priv_lib}/{DB.pm,dumpvar.pl,perl5db.pl}
%dir %{priv_lib}/pod
%{priv_lib}/pod/perldebug.pod
%{_mandir}/man1/perldebug.*
%{_mandir}/man3/DB.*

%files deprecate
%{priv_lib}/deprecate.pm
%{_mandir}/man3/deprecate.*

%files Devel-Peek
%dir %{arch_lib}/Devel
%{arch_lib}/Devel/Peek.pm
%dir %{arch_lib}/auto/Devel
%{arch_lib}/auto/Devel/Peek
%{_mandir}/man3/Devel::Peek.*

%files Devel-SelfStubber
%dir %{priv_lib}/Devel
%{priv_lib}/Devel/SelfStubber.pm
%{_mandir}/man3/Devel::SelfStubber.*

%files diagnostics
%{_bindir}/splain
%{priv_lib}/diagnostics.pm
%dir %{priv_lib}/pod
%{priv_lib}/pod/perldiag.pod
%{_mandir}/man1/perldiag.*
%{_mandir}/man1/splain.*
%{_mandir}/man3/diagnostics.*

%files DirHandle
%{priv_lib}/DirHandle.pm
%{_mandir}/man3/DirHandle.3*

%files doc -f %{SOURCE11}

%files Dumpvalue
%{priv_lib}/Dumpvalue.pm
%{_mandir}/man3/Dumpvalue.3*

%files DynaLoader
%{arch_lib}/DynaLoader.pm
%{_mandir}/man3/DynaLoader.3*

%files encoding-warnings
%dir %{priv_lib}/encoding
%{priv_lib}/encoding/warnings.pm
%{_mandir}/man3/encoding::warnings.3*

%files English
%{priv_lib}/English.pm
%{_mandir}/man3/English.3*

%files Errno
%{arch_lib}/Errno.pm
%{_mandir}/man3/Errno.*

%files ExtUtils-Constant
%dir %{priv_lib}/ExtUtils
%{priv_lib}/ExtUtils/{Constant,Constant.pm}
%{_mandir}/man3/{ExtUtils::Constant::*,ExtUtils::Constant.3*}

%files ExtUtils-Embed
%dir %{priv_lib}/ExtUtils
%{priv_lib}/ExtUtils/Embed.pm
%{_mandir}/man3/ExtUtils::Embed*

%files ExtUtils-Miniperl
%dir %{priv_lib}/ExtUtils
%{priv_lib}/ExtUtils/Miniperl.pm
%{_mandir}/man3/ExtUtils::Miniperl.3*

%files Fcntl
%{arch_lib}/Fcntl.pm
%{arch_lib}/auto/Fcntl
%{_mandir}/man3/Fcntl.3*

%files fields
%{priv_lib}/fields.pm
%{_mandir}/man3/fields.3*

%files File-Basename
%dir %{priv_lib}/File
%{priv_lib}/File/Basename.pm
%{_mandir}/man3/File::Basename.3*

%files File-Compare
%dir %{priv_lib}/File
%{priv_lib}/File/Compare.pm
%{_mandir}/man3/File::Compare.3*

%files File-Copy
%dir %{priv_lib}/File
%{priv_lib}/File/Copy.pm
%{_mandir}/man3/File::Copy.3*

%files File-DosGlob
%dir %{arch_lib}/File
%{arch_lib}/File/DosGlob.pm
%dir %{arch_lib}/auto/File
%{arch_lib}/auto/File/DosGlob
%{_mandir}/man3/File::DosGlob.3*

%files File-Find
%dir %{priv_lib}/File
%{priv_lib}/File/Find.pm
%{_mandir}/man3/File::Find.3*

%files File-stat
%dir %{priv_lib}/File
%{priv_lib}/File/stat.pm
%{_mandir}/man3/File::stat.3*

%files FileCache
%{priv_lib}/FileCache.pm
%{_mandir}/man3/FileCache.3*

%files FileHandle
%{priv_lib}/FileHandle.pm
%{_mandir}/man3/FileHandle.3*

%files filetest
%{priv_lib}/filetest.pm
%{_mandir}/man3/filetest.3*

%files FindBin
%{priv_lib}/FindBin.pm
%{_mandir}/man3/FindBin.*

%if %{with gdbm}
%files GDBM_File
%{arch_lib}/GDBM_File.pm
%{arch_lib}/auto/GDBM_File
%{_mandir}/man3/GDBM_File.3*
%endif

%files Getopt-Std
%dir %{priv_lib}/Getopt
%{priv_lib}/Getopt/Std.pm
%{_mandir}/man3/Getopt::Std.3*

%files Hash-Util
%dir %{arch_lib}/Hash
%{arch_lib}/Hash/Util.pm
%dir %{arch_lib}/auto/Hash
%dir %{arch_lib}/auto/Hash/Util
%{arch_lib}/auto/Hash/Util/Util.so
%{_mandir}/man3/Hash::Util.3*

%files Hash-Util-FieldHash
%dir %{arch_lib}/auto/Hash
%dir %{arch_lib}/auto/Hash/Util
%{arch_lib}/auto/Hash/Util/FieldHash
%dir %{arch_lib}/Hash
%dir %{arch_lib}/Hash/Util
%{arch_lib}/Hash/Util/FieldHash.pm
%{_mandir}/man3/Hash::Util::FieldHash.3*

%files if
%{priv_lib}/if.pm
%{_mandir}/man3/if.3*

%files IO
%dir %{arch_lib}/IO
%{arch_lib}/IO.pm
%{arch_lib}/IO/{Dir.pm,File.pm,Handle.pm,Pipe.pm,Poll.pm,Seekable.pm,Select.pm}
%dir %{arch_lib}/IO/Socket
%{arch_lib}/IO/Socket/INET.pm
%{arch_lib}/IO/Socket/UNIX.pm
%{arch_lib}/IO/Socket.pm
%dir %{arch_lib}/auto/IO
%{arch_lib}/auto/IO/IO.so
%{_mandir}/man3/{IO.*,IO::Dir.*,IO::File.*,IO::Handle.*,IO::Pipe.*,IO::Poll.*,IO::Seekable.*,IO::Select.*,IO::Socket::INET.*,IO::Socket::UNIX.*,IO::Socket.*}

%files IPC-Open3
%dir %{priv_lib}/IPC
%{priv_lib}/IPC/{Open2.pm,Open3.pm}
%{_mandir}/man3/{IPC::Open2.3*,IPC::Open3.3*}

%files I18N-Collate
%dir %{priv_lib}/I18N
%{priv_lib}/I18N/Collate.pm
%{_mandir}/man3/I18N::Collate.*

%files I18N-Langinfo
%{arch_lib}/auto/I18N
%{arch_lib}/I18N
%{_mandir}/man3/I18N::Langinfo.*

%files I18N-LangTags
%dir %{priv_lib}/I18N
%{priv_lib}/I18N/{LangTags,LangTags.pm}
%{_mandir}/man3/{I18N::LangTags.*,I18N::LangTags::*}

%files less
%{priv_lib}/less.pm
%{_mandir}/man3/less.*

%files lib
%{arch_lib}/lib.pm
%{_mandir}/man3/lib.*

%files libnetcfg
%{_bindir}/libnetcfg
%{_mandir}/man1/libnetcfg*

%files locale
%{priv_lib}/locale.pm
%{_mandir}/man3/locale.*

%files Locale-Maketext-Simple
%dir %{priv_lib}/Locale
%dir %{priv_lib}/Locale/Maketext
%{priv_lib}/Locale/Maketext/Simple.pm
%{_mandir}/man3/Locale::Maketext::Simple.*

%files Math-Complex
%dir %{priv_lib}/Math
%{priv_lib}/Math/{Complex.pm,Trig.pm}
%{_mandir}/man3/{Math::Complex.*,Math::Trig.*}

%files Memoize
%{priv_lib}/{Memoize,Memoize.pm}
%{_mandir}/man3/{Memoize::*,Memoize.*}

%files meta-notation
%{priv_lib}/meta_notation.pm

%files Module-Loaded
%dir %{priv_lib}/Module
%{priv_lib}/Module/Loaded.pm
%{_mandir}/man3/Module::Loaded*

%files mro
%{arch_lib}/auto/mro
%{arch_lib}/mro.pm
%{_mandir}/man3/mro.3*

%if %{with gdbm}
%files NDBM_File
%{arch_lib}/NDBM_File.pm
%{arch_lib}/auto/NDBM_File
%{_mandir}/man3/NDBM_File.3*
%endif

%files Net
%dir %{priv_lib}/Net
%{priv_lib}/Net/{hostent.pm,netent.pm,protoent.pm,servent.pm}
%{_mandir}/man3/{Net::hostent.3*,Net::netent.3*,Net::protoent.3*,Net::servent.3*}

%files NEXT
%{priv_lib}/NEXT.pm
%{_mandir}/man3/NEXT.*

%if %{with gdbm}
%files ODBM_File
%{arch_lib}/ODBM_File.pm
%{arch_lib}/auto/ODBM_File
%{_mandir}/man3/ODBM_File.3*
%endif

%files open
%{priv_lib}/open.pm
%{_mandir}/man3/open.3*

%files Opcode
%{arch_lib}/auto/Opcode
%{arch_lib}/{Opcode.pm,ops.pm}
%{_mandir}/man3/{Opcode.3*,ops.3*}

%files overload
%{priv_lib}/overload.pm
%{_mandir}/man3/overload.3*

%files overloading
%dir %{priv_lib}/overload
%{priv_lib}/overload/numbers.pm
%{priv_lib}/overloading.pm
%{_mandir}/man3/overloading.3*

%files ph
%{arch_lib}/{asm,asm-generic,bits,features*.ph,gnu,_h2ph_pre.ph,linux,stdc-predef.ph,sys,syscall.ph}

%files Pod-Functions
%dir %{priv_lib}/Pod
%{priv_lib}/Pod/Functions.pm

%files Pod-Html
%license Pod-Html-license-clarification
%{_bindir}/pod2html
%dir %{priv_lib}/Pod
%{priv_lib}/Pod/{Html,Html.pm}
%{_mandir}/man1/pod2html.1*
%{_mandir}/man3/Pod::Html*

%files POSIX
%{arch_lib}/auto/POSIX
%{arch_lib}/POSIX.*
%{_mandir}/man3/POSIX.*

%files Safe
%{priv_lib}/Safe.pm
%{_mandir}/man3/Safe.*

%files Search-Dict
%{priv_lib}/Search
%{_mandir}/man3/Search::*

%files SelectSaver
%{priv_lib}/SelectSaver.pm
%{_mandir}/man3/SelectSaver.*

%files SelfLoader
%{priv_lib}/SelfLoader.pm
%{_mandir}/man3/SelfLoader.*

%files sigtrap
%{priv_lib}/sigtrap.pm
%{_mandir}/man3/sigtrap.*

%files sort
%{priv_lib}/sort.pm
%{_mandir}/man3/sort.*

%files subs
%{priv_lib}/subs.pm
%{_mandir}/man3/subs.*

%files Symbol
%{priv_lib}/Symbol.pm
%{_mandir}/man3/Symbol.*

%files Sys-Hostname
%dir %{arch_lib}/auto/Sys
%{arch_lib}/auto/Sys/Hostname
%dir %{arch_lib}/Sys
%{arch_lib}/Sys/Hostname.pm
%{_mandir}/man3/Sys::Hostname.*

%files Term-Complete
%dir %{priv_lib}/Term
%{priv_lib}/Term/Complete.pm
%{_mandir}/man3/Term::Complete.*

%files Term-ReadLine
%dir %{priv_lib}/Term
%{priv_lib}/Term/ReadLine.pm
%{_mandir}/man3/Term::ReadLine.*

%files Test
%{priv_lib}/Test.pm
%{_mandir}/man3/Test.*

%files Text-Abbrev
%dir %{priv_lib}/Text
%{priv_lib}/Text/Abbrev.pm
%{_mandir}/man3/Text::Abbrev.*

%files Thread
%{priv_lib}/Thread.pm
%{_mandir}/man3/Thread.*

%files Thread-Semaphore
%dir %{priv_lib}/Thread
%{priv_lib}/Thread/Semaphore.pm
%{_mandir}/man3/Thread::Semaphore.*

%files Tie
%dir %{priv_lib}/Tie
%{priv_lib}/Tie/{Array.pm,Handle.pm,Scalar.pm,StdHandle.pm,SubstrHash.pm}
%{_mandir}/man3/{Tie::Array.*,Tie::Handle.*,Tie::Scalar.*,Tie::StdHandle.*,Tie::SubstrHash.*}

%files Tie-File
%dir %{priv_lib}/Tie
%{priv_lib}/Tie/File.pm
%{_mandir}/man3/Tie::File.*

%files Tie-Memoize
%dir %{priv_lib}/Tie
%{priv_lib}/Tie/Memoize.pm
%{_mandir}/man3/Tie::Memoize.*

%files Time
%dir %{priv_lib}/Time
%{priv_lib}/Time/{gmtime.pm,localtime.pm,tm.pm}
%{_mandir}/man3/{Time::gmtime.*,Time::localtime.*,Time::tm.*}

%files Time-Piece
%dir %{arch_lib}/Time
%{arch_lib}/Time/{Piece.pm,Seconds.pm}
%dir %{arch_lib}/auto/Time
%{arch_lib}/auto/Time/Piece
%{_mandir}/man3/{Time::Piece.3*,Time::Seconds.3*}

%files Unicode-UCD
%dir %{priv_lib}/Unicode
%{priv_lib}/Unicode/UCD.pm
%{_mandir}/man3/Unicode::UCD.*

%files User-pwent
%{priv_lib}/User
%{_mandir}/man3/User::*

%files vars
%{priv_lib}/vars.pm
%{_mandir}/man3/vars.*

%files vmsish
%{priv_lib}/vmsish.pm
%{_mandir}/man3/vmsish.*

%changelog
* Wed Apr 2 2025 Kaiqiang Wang <wangkaiqiang@ieisystem.com> - 5.36.3-16
- add Perl_my_strlcat and Perl_my_strlcpy symbol

* Thu Nov 30 2023 Funda Wang <fundawang@yeah.net> - 5.36.3-15
- New version 5.36.3

* Sun Nov 26 2023 Funda Wang <fundawang@yeah.net> - 5.36.2-14
- New version 5.36.2

* Sat Oct 28 2023 happy_orange <songnannan@linux.alibaba.com> - 5.36.1-13
- rollback to 5.36.1-11 because the CVE-2023-31484 and CVE-2023-31486 has been fixed in perl-CPAN and perl-HTTP-Tiny package.

* Fri Oct 20 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 5.36.1-12
- fix CVE-2023-31484 and fix CVE-2023-31486

* Tue Jul 11 2023 Funda Wang <fundawang@yeah.net> - 5.36.1-11
- New version 5.36.1

* Wed Apr 12 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 5.36.0-10
- fix requires info of perl-libs

* Tue Apr 11 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 5.36.0-9
- optimise spec file

* Fri Feb 03 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 5.36.0-8
- Perl 5.36 re-rebuild of bootstrapped packages
- remove versioned MODULE_COMPAT_ requires

* Sun Jan 29 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 5.36.0-7
- update to 5.36.0
- add back bootstrap modules to rebuild

* Fri Apr 08 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 5.34.0-6
- remove libdb and DB_File

* Wed Mar 16 2022 Shile Zhang <shile.zhang@linux.alibaba.com> - 5.34.0-5
- add GDBM supports (Shile Zhang)

* Tue Mar 15 2022 Shile Zhang <shile.zhang@linux.alibaba.com> - 5.34.0-4
- add perl-marcors package (Shile Zhang)

* Tue Mar 15 2022 Shile Zhang <shile.zhang@linux.alibaba.com> - 5.34.0-3
- add compat macro for rebuild (Shile Zhang)

* Tue Mar 15 2022 Shile Zhang <shile.zhang@linux.alibaba.com> - 5.34.0-2
- set libperl soname (Shile Zhang)

* Thu Mar 10 2022 Shile Zhang <shile.zhang@linux.alibaba.com> - 5.34.0-1
- init commit for Anolis OS 23 (Shile Zhang)
